<?php  
/*
Plugin Name: Ad Buttons
Plugin URI: http://blogio.net/blog/wp-ad-plugin/
Description: Plugin to add ad buttons to your blog
Author: Nico
Version: 1.4.1
Author URI: http://www.blogio.net/blog/
Questions, sugestions, problems? Let me know at nico@blogio.net
*/
$ad_buttons_db_version = "1.4";

function ad_buttons_install()
{
	//set the options
	$newoptions = get_option('widget_adbuttons_cfg');
	$newoptions['ab_dspcnt'] = '1';
	$newoptions['ab_target'] = 'bnk';
	add_option('widget_adbuttons_cfg', $newoptions);
	
	// create table
    global $wpdb;
    $table = $wpdb->prefix."ad_buttons";
    $structure = "CREATE TABLE $table (
        id INT(9) NOT NULL AUTO_INCREMENT,
        ad_picture VARCHAR(100) NOT NULL,
        ad_link VARCHAR(80) NOT NULL,
		ad_text VARCHAR(80) NOT NULL,
        ad_strdat DATE NOT NULL,
		ad_enddat DATE NOT NULL,
        ad_views INT(9) DEFAULT 0,
		ad_clicks INT(9) DEFAULT 0,
		ad_active TINYINT(1) NOT NULL DEFAULT 0,
	UNIQUE KEY id (id)
    );";
	
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($structure);
	
    $wpdb->query("INSERT INTO $table(id, ad_picture, ad_link, ad_text, ad_views, ad_clicks, ad_active)
        VALUES(1, 'http://blogio.net/ad_buttons_125.jpg', 'http://blogio.net/blog/wp-ad-plugin/', 'ads powered by Ad Buttons', 1, 0, 1)");

	add_option("ad_buttons_db_version", $ad_buttons_db_version);

}

register_activation_hook(__FILE__,'ad_buttons_install');

   //check if user is a bot of some sort
function is_bot()
{
    $bots = array('google','yahoo','msn','jeeves','lycos','ArchitectSpider','whatuseek','BSDSeek','BullsEye');
    //takes the list above and returns (google)|(yahoo)|(msn)...
    $regex = '('.implode($bots, ')|(').')';
    //uses the generated regex above to see if those keywords are contained in the user agent variable    
    return eregi($regex, $_SERVER['HTTP_USER_AGENT']);
}

function ad_buttons()
{
    global $wpdb;
$widget_adbuttons_cfg = array(

	'ab_dspcnt'				=> '',
	'ab_target' 			=> '',
	'ab_adsense' 			=> '',
	'ab_adsense_fixed'		=> '',
	'ab_adsense_pos'		=> '',
	'ab_adsense_pubid'		=> '',
	'ab_adsense_channel'	=> '',
	'ab_adsense_corners'	=> '',
	'ab_adsense_col_border'	=> '',
	'ab_adsense_col_title'	=> '',
	'ab_adsense_col_bg'		=> '',
	'ab_adsense_col_txt'	=> '',
	'ab_adsense_col_url'	=> '',
	'ab_width'				=> '',
	'ab_padding'			=> '',
	'ab_nofollow'			=> ''

);

$widget_adbuttons_cfg = get_option('widget_adbuttons_cfg');
$wp_root = get_option('home');

if($widget_adbuttons_cfg['ab_nofollow']){
	$ab_nofollow = ' rel="nofollow" ';
}

if($widget_adbuttons_cfg['ab_adsense']){
	$ab_adsense_ad = '<div id="ab_adsense">
	<script type="text/javascript"><!--
google_ad_client = "'.$widget_adbuttons_cfg['ab_adsense_pubid'].'";
google_ad_width = 125;
google_ad_height = 125;
google_ad_format = "125x125_as";
google_ad_type = "text_image";
google_ad_channel = "'.$widget_adbuttons_cfg['ab_adsense_channel'].'";
google_color_border = "'.$widget_adbuttons_cfg['ab_adsense_col_border'].'";
google_color_bg = "'.$widget_adbuttons_cfg['ab_adsense_col_bg'].'";
google_color_link = "'.$widget_adbuttons_cfg['ab_adsense_col_title'].'";
google_color_text = "'.$widget_adbuttons_cfg['ab_adsense_col_txt'].'";
google_color_url = "'.$widget_adbuttons_cfg['ab_adsense_col_url'].'";
google_ui_features = "'.$widget_adbuttons_cfg['ab_adsense_corners'].'";
//-->
</script>
<script type="text/javascript"
  src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script></div>';
	}
	
if($widget_adbuttons_cfg['ab_target'] == 'bnk'){
	$target = " target=\"_blank\" ";
	}
elseif($widget_adbuttons_cfg['ab_target'] == 'top'){
	$target = " target=\"_top\" ";
	}
elseif($widget_adbuttons_cfg['ab_target'] == 'non'){
	$target = " ";
	}


if($widget_adbuttons_cfg['ab_adsense']){
	$ab_count = 1;
	}
else {
	$ab_count = 0;
	}
	
echo'
<style type="text/css">
#ab_adblock
{
width: '.$widget_adbuttons_cfg['ab_width'].'px;
padding:'.$widget_adbuttons_cfg['ab_padding'].'px;
}
#ab_adblock a
{
float: left;
padding:'.$widget_adbuttons_cfg['ab_padding'].'px;
}
#ab_adsense
{
float: left;
padding:'.$widget_adbuttons_cfg['ab_padding'].'px;
}
#ab_clear
{
clear: both;
}
</style>'; 
echo '<div id="ab_adblock">';
$results = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."ad_buttons WHERE 
ad_active = 1 AND ad_strdat <= CURDATE() AND ad_enddat > CURDATE() OR 
ad_active = 1 AND ad_strdat <= CURDATE() AND ad_enddat = '0000-00-00' ORDER BY RAND()");
foreach($results as $result){
	if ($ab_count < $widget_adbuttons_cfg['ab_dspcnt']) {
		if($widget_adbuttons_cfg['ab_adsense']){
			if($widget_adbuttons_cfg['ab_adsense_pos']==$ab_count){
				echo $ab_adsense_ad;
			}
		}
		echo"<a href=\"$wp_root/index.php?recommends=$result->id\" $target title=\"$result->ad_text\" $ab_nofollow><img src=\"$result->ad_picture\" alt=\"$result->ad_text\"  vspace=\"1\" hspace=\"1\" border=\"0\"></a>";
		$ab_count = $ab_count + 1;
		// update view counter on the ad button
		if(!is_bot()) {
			$wpdb->query("UPDATE ".$wpdb->prefix."ad_buttons 
    	   		SET ad_views = ad_views + 1 WHERE id = ".$result->id);
		}
	}
}
if($widget_adbuttons_cfg['ab_adsense']){
	if($widget_adbuttons_cfg['ab_adsense_pos']==$ab_count){
		echo $ab_adsense_ad;
		}
	}
echo '<div id="ab_clear"></div></div>';
}

function ad_buttons_settings()
{
    global $wpdb;
    include 'adbuttonsadmin.php';
}
 
function ad_buttons_stats()
{
    global $wpdb;
    include 'adbuttonsstats.php';
}

function ad_buttons_top()
{
    global $wpdb;
    include 'adbuttonstop.php';
}
 
function ad_buttons_act()
{
    global $wpdb;
    include 'adbuttonsact.php';
}

function ad_buttons_stats_actions()
{
	
	add_menu_page('Ad Buttons', 'Ad Buttons', 9, __FILE__, 'ad_buttons_act', get_option('home').'/'.PLUGINDIR.'/'.dirname(plugin_basename(__FILE__)).'/ad_buttons_icon.png');
	// Add a submenu to the custom top-level menu:
	add_submenu_page(__FILE__, 'Ad Buttons Settings', 'Settings', 9, 'ad-buttons-settings', 'ad_buttons_settings');
}


add_action('admin_menu', 'ad_buttons_stats_actions');


// process ad clicks
function adbuttons_getclick()
{
global $wpdb;
	if(isset($_GET['recommends'])) {
		$ad_id = $_GET['recommends'];
		if(is_numeric($ad_id)){
			$results = $wpdb->get_results("SELECT ad_link FROM ".$wpdb->prefix."ad_buttons WHERE id = $ad_id LIMIT 1");
			foreach($results as $result){
				$send_to_url = $result->ad_link;
				if(!is_bot()) {
					$wpdb->query("UPDATE ".$wpdb->prefix."ad_buttons 
    	   				SET ad_clicks = ad_clicks + 1 WHERE id = ".$ad_id);
				}
				//redirect
				header("Location: ".$send_to_url);
				exit(0);
			}
		}

	}
}
	
// widget
function widget_init_adbuttons_widget() {
	// Check for required functions
	if (!function_exists('register_sidebar_widget'))
		return;

	function adbuttons_widget($args){
	    extract($args);
		$options = get_option('widget_adbuttons_cfg');
		$title = empty($options['title']) ? __('Sponsored Links') : $options['title'];
		?>
	        <?php echo $before_widget; ?>
				<?php echo $before_title . $title . $after_title; ?>
				<?php 
					if( !stristr( $_SERVER['PHP_SELF'], 'widgets.php' ) ){
						ad_buttons();
					}
				?>
	        <?php echo $after_widget; ?>
		<?php
	}
	
	function adbuttons_widget_control() {
		$options = $newoptions = get_option('widget_adbuttons_cfg');
		if ( $_POST["adbuttons_widget_submit"] ) {
			$newoptions['title'] = strip_tags(stripslashes($_POST["adbuttons_widget_title"]));
		}
		if ( $options != $newoptions ) {
			$options = $newoptions;
			update_option('widget_adbuttons_cfg', $options);
		}
		$title = attribute_escape($options['title']);
		?>
			<p><label for="adbuttons_widget_title"><?php _e('Title:'); ?> <input class="widefat" id="adbuttons_widget_title" name="adbuttons_widget_title" type="text" value="<?php echo $title; ?>" /></label></p>
			<input type="hidden" id="adbuttons_widget_submit" name="adbuttons_widget_submit" value="1" />
		<?php
	}
	
	register_sidebar_widget( "Ad Buttons", "adbuttons_widget" );
	register_widget_control( "Ad Buttons", "adbuttons_widget_control" );
}

// Delay plugin execution until sidebar is loaded
add_action('widgets_init', 'widget_init_adbuttons_widget');

add_action("init", "adbuttons_getclick"); 

?>
